<template>
  <el-col
    :xs="24"
    :sm="24"
    :lg="8"
    v-loading="isLoading"
    style="margin-bottom: 1%"
  >
    <el-card id="tour-info-component">
      <span style="margin: 1px; font-weight: bold">Месяц: </span>
      <span v-if="mediaPlan">{{
        getStringifyMediaPlanDate(mediaPlan.month)
      }}</span>
      <br />
      <span style="margin: 1px; font-weight: bold">Рекламодатель: </span>
      <span v-if="mediaPlan">
        {{ mediaPlan.order.agreement.advertiser.name }}
      </span>
      <br />
      <span style="margin: 1px; font-weight: bold">Заказ: </span>
      <span v-if="mediaPlan"> {{ mediaPlan.order.name }}</span>
      <br />
      <span style="margin: 1px; font-weight: bold">Медиаплан: </span>
      <span v-if="mediaPlan"> {{ mediaPlan.name }}</span>
    </el-card>
  </el-col>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { MediaPlan } from "@/interfaces/MediaPlan";
import ComponentMixin from "@/components/common/ComponentMixin";

/**
 * Компонент данных медиаплана.
 */
@Component
export default class InformationComponent extends Mixins(ComponentMixin) {
  /**
   * Состояние индикатора загрузки.
   */
  private isLoading = true;

  /**
   * Медиаплан.
   */
  private mediaPlan: null | MediaPlan = null;

  /**
   * Метод срабатывает после создания компонента.
   */
  protected created(): void {
    // Подписываемся на событие получения информации о медиаплане
    this.subscribe("media-plan-response", this.onMediaPlanResponse);
  }

  /**
   * Метод срабатывает после получения информации о медиаплане.
   * @param {MediaPlan} mediaPlan медиаплан.
   */
  private onMediaPlanResponse(mediaPlan: MediaPlan): void {
    // Сохраняем медиаплан в переменную
    this.mediaPlan = mediaPlan;

    // Отключаем индикатор загрузки
    setTimeout(() => {
      this.isLoading = false;
    }, 200);
  }

  /**
   * Метод получения строкового представления даты медиаплана.
   * @param {Date} date дата медиаплана.
   * @return {string} строковое представление даты медиаплана.
   */
  private getStringifyMediaPlanDate(date: Date): string {
    const monthName = date.toLocaleString("default", {
      month: "long",
      year: "numeric",
    });
    return monthName.charAt(0).toUpperCase() + monthName.slice(1);
  }
}
</script>

<style lang="scss" scoped>
.el-card {
  height: 100%;
}
</style>
